SynthListUI (Java SE 9 & JDK 9 )
Keywords: javax.swing.plaf.synth.SynthListUI class

Module java.desktop
Package javax.swing.plaf.synth

## Class SynthListUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.ListUI
    - - javax.swing.plaf.basic.BasicListUI
      - - javax.swing.plaf.synth.SynthListUI

- All Implemented Interfaces:
    `PropertyChangeListener`, `EventListener`, `SynthConstants`, `SynthUI`

      public class SynthListUI
      extends BasicListUI
      implements PropertyChangeListener, SynthUI

  Provides the Synth L&F UI delegate for `JList`.
  Since:
    1.7

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.plaf.basic.BasicListUI

      `BasicListUI.FocusHandler, BasicListUI.ListDataHandler, BasicListUI.ListSelectionHandler, BasicListUI.MouseInputHandler, BasicListUI.PropertyChangeHandler`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.plaf.basic.BasicListUI

      `cellHeight, cellHeights, cellRendererChanged, cellWidth, fixedCellHeightChanged, fixedCellWidthChanged, focusListener, fontChanged, list, listDataListener, listSelectionListener, modelChanged, mouseInputListener, propertyChangeListener, prototypeCellValueChanged, rendererPane, selectionModelChanged, updateLayoutStateNeeded`

    - ### Fields inherited from interface javax.swing.plaf.synth.SynthConstants

      `DEFAULT, DISABLED, ENABLED, FOCUSED, MOUSE_OVER, PRESSED, SELECTED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SynthListUI​()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static ComponentUI` | `createUI​(JComponent list)` | Creates a new UI object for the given component.
    `SynthContext` | `getContext​(JComponent c)` | Returns the Context for the specified component.
    `protected void` | `installDefaults​()` | Initializes list properties such as font, foreground, and background, and adds the CellRendererPane.
    `protected void` | `installListeners​()` | Creates and installs the listeners for the JList, its model, and its selectionModel.
    `void` | `paintBorder​(SynthContext context, Graphics g, int x, int y, int w, int h)` | Paints the border.
    `void` | `propertyChange​(PropertyChangeEvent e)` | This method gets called when a bound property is changed.
    `protected void` | `uninstallDefaults​()` | Sets the list properties that have not been explicitly overridden to `null`.
    `protected void` | `uninstallListeners​()` | Removes the listeners from the JList, its model, and its selectionModel.
    `void` | `update​(Graphics g, JComponent c)` | Notifies this UI delegate to repaint the specified component.

    - ### Methods inherited from class javax.swing.plaf.basic.BasicListUI

      `convertRowToY, convertYToRow, createFocusListener, createListDataListener, createListSelectionListener, createMouseInputListener, createPropertyChangeListener, getBaseline, getBaselineResizeBehavior, getCellBounds, getPreferredSize, getRowHeight, indexToLocation, installKeyboardActions, installUI, locationToIndex, maybeUpdateLayoutState, paint, paintCell, selectNextIndex, selectPreviousIndex, uninstallKeyboardActions, uninstallUI, updateLayoutState`

    - ### Methods inherited from class javax.swing.plaf.ComponentUI

      `contains, getAccessibleChild, getAccessibleChildrenCount, getMaximumSize, getMinimumSize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SynthListUI

          public SynthListUI​()

  - ### Method Detail

    - #### createUI

          public static ComponentUI createUI​(JComponent list)

      Creates a new UI object for the given component.
      Parameters:
        `list` - component to create UI object for
      Returns:
        the UI object

    - #### update

          public void update​(Graphics g,
                             JComponent c)

      Notifies this UI delegate to repaint the specified component. This method paints the component background, then calls the `BasicListUI.paint(java.awt.Graphics, javax.swing.JComponent)` method.

      In general, this method does not need to be overridden by subclasses. All Look and Feel rendering code should reside in the `paint` method.

      Overrides:
        `update` in class `ComponentUI`
      Parameters:
        `g` - the `Graphics` object used for painting
        `c` - the component being painted
      See Also:
        `BasicListUI.paint(java.awt.Graphics, javax.swing.JComponent)`

    - #### paintBorder

          public void paintBorder​(SynthContext context,
                                  Graphics g,
                                  int x,
                                  int y,
                                  int w,
                                  int h)

      Paints the border.
      Specified by:
        `paintBorder` in interface `SynthUI`
      Parameters:
        `context` - a component context
        `g` - `Graphics` to paint on
        `x` - the X coordinate
        `y` - the Y coordinate
        `w` - width of the border
        `h` - height of the border

    - #### installListeners

          protected void installListeners​()

      Creates and installs the listeners for the JList, its model, and its selectionModel. This method is called at installUI() time.
      Overrides:
        `installListeners` in class `BasicListUI`
      See Also:
        `BasicListUI.installUI(javax.swing.JComponent)`, `BasicListUI.uninstallListeners()`

    - #### propertyChange

          public void propertyChange​(PropertyChangeEvent e)

      This method gets called when a bound property is changed.
      Specified by:
        `propertyChange` in interface `PropertyChangeListener`
      Parameters:
        `e` - A PropertyChangeEvent object describing the event source and the property that has changed.

    - #### uninstallListeners

          protected void uninstallListeners​()

      Removes the listeners from the JList, its model, and its selectionModel. All of the listener fields, are reset to null here. This method is called at uninstallUI() time, it should be kept in sync with installListeners.
      Overrides:
        `uninstallListeners` in class `BasicListUI`
      See Also:
        `BasicListUI.uninstallUI(javax.swing.JComponent)`, `BasicListUI.installListeners()`

    - #### installDefaults

          protected void installDefaults​()

      Initializes list properties such as font, foreground, and background, and adds the CellRendererPane. The font, foreground, and background properties are only set if their current value is either null or a UIResource, other properties are set if the current value is null.
      Overrides:
        `installDefaults` in class `BasicListUI`
      See Also:
        `BasicListUI.uninstallDefaults()`, `BasicListUI.installUI(javax.swing.JComponent)`, `CellRendererPane`

    - #### uninstallDefaults

          protected void uninstallDefaults​()

      Sets the list properties that have not been explicitly overridden to `null`. A property is considered overridden if its current value is not a `UIResource`.
      Overrides:
        `uninstallDefaults` in class `BasicListUI`
      See Also:
        `BasicListUI.installDefaults()`, `BasicListUI.uninstallUI(javax.swing.JComponent)`, `CellRendererPane`

    - #### getContext

          public SynthContext getContext​(JComponent c)

      Returns the Context for the specified component.
      Specified by:
        `getContext` in interface `SynthUI`
      Parameters:
        `c` - Component requesting SynthContext.
      Returns:
        SynthContext describing component.